Models/Department.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Asp.netCore.Models
{
    public class Department
    {
        public int DepartmentId { get; set; }
        [Required]
        [Display(Name = " نام شرکت ")]
        public string Name { get; set; }
    }
}

Models/Employee.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Asp.netCore.Models
{
    public class Employee
    {
        public int EmployeeId { get; set; }
        [Required]
        [Display(Name = " نام و نام خانوادگی ")]
        public string Name { get; set; }
        [Required]
        [Display(Name = "حقوق دریافتی ")]
        public decimal Salary { get; set; }
        public int? BossId { get; set; }
        public Employee Boss { get; set; }
        public int DepartmentId { get; set; }
        public Department Department { get; set; }
    }
}

ViewModels/DepartmentViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Asp.netCore.ViewModels
{
    public class DepartmentViewModel
    {
        [Required]
        [Display(Name = " نام شرکت ")]
        public string Name { get; set; }
    }
}

ViewModels/EmployeeViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Asp.netCore.ViewModels
{
    public class EmployeeViewModel
    {
        public int EmployeeId { get; set; }
        [Required]
        [Display(Name = " نام و نام خانوادگی ")]
        public string Name { get; set; }
        [Required]
        [Display(Name = "حقوق دریافتی ")]
        public decimal Salary { get; set; }
        public int? BossId { get; set; }
        public EmployeeViewModel Boss { get; set; }
        public int DepartmentId { get; set; }
        public DepartmentViewModel Department { get; set; }
    }
}

Controllers/EmployeeController.cs
using Asp.netCore.Models;
using Asp.netCore.Services;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Asp.netCore.Controllers
{
    public class EmployeeController : Controller
    {
        private readonly IEmployeeService _service;
        public EmployeeController(IEmployeeService service)
        {
            _service = service;
        }
        public async Task<ActionResult<IEnumerable<Employee>>> Index()
        {
            var employees = await _service.GetAllEmploeeysAsync();
            return View(employees);
        }
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
                return NotFound();
            Employee employee = await _service.GetEmployeeAsync(id);
            if (employee == null) return NotFound();
            return View(employee);
        }
        public IActionResult Create()
        {
            ViewBag.Bosses = _service.GetDropDownEmployees();
            ViewBag.Departments = _service.GetDropDownDepartments();
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(Employee employee)
        {
            if (ModelState.IsValid)
            {
                await _service.AddAsync(employee);
                return RedirectToAction(nameof(Index));
            }
            return View(employee);
        }
        // GET: Employees/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }
            Employee employee = await _service.GetEmployeeAsync(id);
            if (employee == null)
            {
                return NotFound();
            }
            ViewBag.Bosses = _service.GetDropDownEmployees();
            ViewBag.Departments = _service.GetDropDownDepartments();
            return View(employee);
        }
        // POST: Employees/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, Employee employee)
        {
            if (id != employee.EmployeeId)
            {
                return NotFound();
            }
            if (ModelState.IsValid)
            {
                await _service.UpdateAsync(employee);
                return View(employee);
            }
            else
            {
                return RedirectToAction(nameof(Index));
            }
        }
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }
            Employee employee = await _service.GetEmployeeAsync(id);
            if (employee == null)
            {
                return NotFound();
            }
            return View(employee);
        }
        // POST: Employees/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await _service.DeleteConfirmedAsync(id);
            return RedirectToAction(nameof(Index));
        }
    }
}

Views/Employee/Create.cshtml
@model Asp.netCore.Models.Employee
@{
    ViewData["Title"] = "افزودن کارمند "; }
<h1 class="d-flex justify-content-center">افزودن کارمند </h1>
<hr />
<div class="row" dir="rtl">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            
            <div class="form-group">
                <label asp-for="Name" class="control-label" dir="rtl"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Salary" class="control-label"></label>
                <input asp-for="Salary" class="form-control" />
                <span asp-validation-for="Salary" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">نام ریئس </label> <select asp-for="BossId" asp-items=@ViewBag.Bosses class="form-control"></select>
                <span asp-validation-for="BossId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">نام شرکت </label> <select asp-for="DepartmentId" asp-items=@ViewBag.Departments class="form-control"></select>
                <span asp-validation-for="DepartmentId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="ذخیره " class="btn btn-success" />
            </div>
        </form>
    </div>
</div>
<div>
    <a class="btn btn-info" asp-action="Index">صفحه اصلی </a>
</div>

Views/Employee/Delete.cshtml
@model Asp.netCore.Models.Employee
@{
    ViewBag.Title = "جزئیات کارمند ";
}
    <div class="offset-4">
        <h1 class="d-flex justify-content-center">حذف کارمند </h1>
        <form asp-action="Delete" method="post">
            <div class="form-group">
                <table dir="rtl" class=" table">
                    <tr>
                        <th> @Html.DisplayNameFor(model => model.Name) </th>
                        <td> @Html.DisplayFor(model => model.Name)</td>
                    </tr>
                    <tr>
                        <th> @Html.DisplayNameFor(model => model.Department.Name)</th>
                        <td> @Html.DisplayFor(model => model.Department.Name)</td>
                    </tr>
                    <tr>
                        <th> نام رییس : </th>
                        <td> @Html.DisplayFor(model => model.Boss.Name)</td>
                    </tr>
                    <tr>
                        <th> @Html.DisplayNameFor(model => model.Salary) </th>
                        <td> @Html.DisplayFor(model => model.Salary)</td>
                    </tr>
                    <tr>
                        <td><a class="btn btn-success" asp-action="Delete" asp-route-id="@Model.EmployeeId">حذف </a></td>
                    </tr>
                </table>
                </div>
                <div class="form-group">
                    @* <a class="btn btn-primary" asp-action="Edit" asp-route-id="{@ViewBag.EmployeeId , @ViewBag.Employee}}">جزئیات </a> |*@
                    <input type="submit" value="حذف " class="btn btn-success" />
                </div>
        </form>
    </div>

Views/Employee/Details.cshtml
@model Asp.netCore.Models.Employee
@{
    ViewBag.Title = "جزئیات کارمند "; 
}
<div class="offset-4">
    <h1 class="d-flex justify-content-center">جزئیات کارمند </h1>
    <table dir="rtl" class=" table">
        <tr>
            <th> @Html.DisplayNameFor(model => model.Name) </th>
            <td> @Html.DisplayFor(model => model.Name)</td>
        </tr>
        <tr>
            <th> @Html.DisplayNameFor(model => model.Department.Name)</th>
            <td> @Html.DisplayFor(model => model.Department.Name)</td>
        </tr>
        <tr>
            <th> نام رییس : </th>
            <td> @Html.DisplayFor(model => model.Boss.Name)</td>
        </tr>
        <tr>
            <th> @Html.DisplayNameFor(model => model.Salary) </th>
            <td> @Html.DisplayFor(model => model.Salary)</td>
        </tr>
        <tr>
            <th> <a class="btn btn-info" asp-action="Index">صفحه اصلی </a> </th>
            <td><a class="btn btn-success" asp-action="Edit" asp-route-id="@Model.EmployeeId">ویرایش </a></td>
        </tr>
    </table>
</div>

Views/Employee/Edit.cshtml
@model Asp.netCore.Models.Employee
@{
    ViewData["Title"] = "ویرایش کارمند "; }
<h1 class="d-flex justify-content-center">ویرایش کارمند </h1>
<hr />
<div class="row" dir="rtl">
    <div class="col-md-4">
        <form asp-action="Edit" method="post">
            <div asp-validation-summary="ModelOnly" class="text- danger"></div>
            <input type="hidden" asp-for="EmployeeId" />
            <div class="form-group">
                <label asp-for="Name" class="control-label" dir="rtl"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Salary" class="control-label"></label>
                <input asp-for="Salary" class="form-control" />
                <span asp-validation-for="Salary" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">نام ریئس </label> <select asp-for="BossId" asp-items=@ViewBag.Bosses class="form-control"></select>
                <span asp-validation-for="BossId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">نام شرکت </label>
                <select asp-for="DepartmentId" asp-items=@ViewBag.Departments class="form-control"></select>
                <span asp-validation-for="DepartmentId" class="text-danger"></span>
            </div>
            <div class="form-group">
               @* <a class="btn btn-primary" asp-action="Edit" asp-route-id="{@ViewBag.EmployeeId , @ViewBag.Employee}}">جزئیات </a> |*@
                <input type="submit" value="ذخیره " class="btn btn-success" />
            </div>
        </form>
    </div>
</div>
<div>
    <a class="btn btn-info" asp-action="Index">صفحه اصلی </a>
</div>

Views/Employee/Index.cshtml
@model IEnumerable<Asp.netCore.Models.Employee>;
@{ 
    ViewData["Title"] = "کارمندان ";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<div dir="rtl">
    <h1 class="d-flex justify-content-center">لیست کارمندان </h1>
</div>
<p>
    <a class="btn btn-success" asp-action="Create"> افزودن کارمند </a>
</p>
<table class="table" dir="rtl">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Salary)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.BossId)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.DepartmentId)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Salary)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Department.Name)
                </td>
                <td>
                    <a class="btn btn-primary" asp-action="Details" asp-route-id="@item.EmployeeId">جزئیات </a> |
                    <a class="btn btn-info" asp-action="Edit" asp-route-id="@item.EmployeeId">ویرایش </a> |
                    <a class="btn btn-danger" asp-action="Delete" asp-route-id="@item.EmployeeId">حذف </a>
                </td>
            </tr>
        }
    </tbody>
</table>

Views/Shared/_Layout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>@ViewBag.Title</title>
    <link href="~/vendor/bootstrap/dist/css/bootstrap.min.css" rel="stylesheet" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Employee" asp-
                   action="Index">MicrodevProject</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Employee" asp-action="Index">کارمند </a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-
                               controller="Departmant" asp-action="Privacy">دپارتمان </a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>
    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2019 - MicrodevProject - Zahra Bayat
        </div>
    </footer>

    <script src="~/vendor/jquery/dist/jquery.min.js"></script>
    <script src="~/vendor/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
</body>
</html>